=== debian/changelog ===
monero (0.12.3.0~dfsg-1) unstable; urgency=medium

  [ upstream ]
  * New release.

  [ Jonas Smedegaard ]
  * Improve long description, to talk about project first and specific
    package parts last.
  * Declare source package as not requiring root to build.
  * Declare compliance with Debian Policy 4.1.5.
  * Improve avoiding tests requiring network:
    + Set GTEST_FILTER.
    + Drop patch 2002.
    Thanks to upstream Monero developers.
  * Improve testing:
    + Add binary package monero-tests.
    + Add autopkgtest, using newly added package monero-tests.
    + Emit testsuite details only on error.
    + Avoid core_tests during build (only in autopkgtest).
  * Build-depend on libdb-dev.

 -- Jonas Smedegaard <dr@jones.dk>  Sat, 07 Jul 2018 14:31:55 +0200

monero (0.12.2.0~dfsg-3) unstable; urgency=medium

  * Avoid building with -maes: Horribly handled for non-x86 archs, and
    not generally supported even on amd64.

 -- Jonas Smedegaard <dr@jones.dk>  Thu, 21 Jun 2018 09:54:34 +0200

monero (0.12.2.0~dfsg-2) unstable; urgency=medium

  * Update copyright info: Fix list files copyright Google.
    Closes: Bug#901915. Thanks to Chris Lamb.
  * Update package relations:
    + Build-depend on qtchooser, needed to generate translation files.
    + Stop build-depend on libunwind-dev: Unneeded (internal fork of
      easylogging++ used instead).

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 20 Jun 2018 21:51:20 +0200

monero (0.12.2.0~dfsg-1) unstable; urgency=low

    * Initial Release.
      Closes: bug#890974. Thanks to Guido Günther and Subgraph.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 19 Jun 2018 11:26:34 +0200
